#include "defs.h"
#include <ctype.h>
#include <time.h>

#undef DEBUG

buildpym(struct img_set *img_set, struct img_set *key_set, struct info_pym *info_pym, int nbrel, int *relevance);

main()
{
  struct img_set img_set, key_set;
  struct feature *featureblock;
  struct info_pym info_pym;
  char   db_name[256];
  float  weight[nbweight];
  float  filter;
  float  rsize;
  int    i;


  for (i=0; i<nbweight; i++) weight[i] = 1.0;
  filter = 1.0;
  rsize = 1.0;
  setWeight(weight);
  setFilter(filter);
  setHeurist(rsize);

  fprintf(stdout, "Reading lists from image database\n");
  sprintf(db_name, "db_folderNEW");
  get_img_info(&img_set, db_name, "feature", 0, 0);
  read_img_set(&img_set, db_name, "feature", "rb");
  fprintf(stdout, "%d images\n", img_set.num_img);

  allocate_img_info(&key_set, img_set.num_img / 2);
  featureblock = (struct feature *) malloc(key_set.max_img * sizeof(struct feature));
  for (i=0; i<key_set.max_img; i++) key_set.img[i].feature = &featureblock[i];
  buildpym(&img_set, &key_set, &info_pym, 0, NULL);

  write_img_tree(&img_set, &key_set, db_name, "SFLEXIBLE");
  write_img_info(&key_set, db_name, "SFLEXIBLE");
  write_info_pym(&img_set, &key_set, &info_pym, db_name, "SFLEXIBLE");

}


buildpym(struct img_set *img_set, struct img_set *key_set, struct info_pym *info_pym, int nbrel, int *relevance) 
{
  struct img_set work_set;
  struct img_info *curimg, *root;
  struct feature dfeature;

  allocate_img_info(&work_set, img_set->num_img);

  fprintf(stdout, "Building Binary Tree\n");
  buildtree2(img_set, &work_set);

  /* code from regroup.c */
  root = img_set->root;
  root->next = NULL;
  root->key  = NULL;
  root->feature = &dfeature;
  reset_feature(root->feature);
  fprintf(stdout, "Converting to Quad-Tree\n");
  regroup(img_set, &work_set, key_set, root, 0, 0, NULL);

  if (root->type == 1) img_set->root = key_set->root = root->child;
  for (curimg=img_set->root; curimg!=NULL; curimg=curimg->next) {
    curimg->key = NULL;
    curimg->dist = MAXVALUE;
  }

  /* code from mapping.c */
  fprintf(stdout, "Mapping to Pyramid\n");
  mapping(img_set);

  fprintf(stdout, "End of Build pyramid\n");

  free_img_info(&work_set);


}
